<p align="center">
  <a href="https://gohugo.io">
    <img alt="Hugo" src="https://img.shields.io/badge/Built%20with-Hugo-ff4088?logo=hugo&logoColor=white&style=for-the-badge">
  </a>
  <a href="https://codeberg.org/chlorine/hugo-theme-hermeneutics">
    <img alt="Theme: Hermeneutics" src="https://img.shields.io/badge/Theme-Hermeneutics-8e44ad?style=for-the-badge">
  </a>
</p>

<p align="center">
  <a href="https://codeberg.org/chlorine/blog">
    <img alt="Codeberg" src="https://img.shields.io/badge/Codeberg-Code-blue?logo=codeberg&style=for-the-badge">
  </a>
  <a href="https://foss.moe/chlorine/blog">
    <img alt="Forgejo" src="https://img.shields.io/badge/Forgejo-Code-F05033?logo=forgejo&style=for-the-badge">
  </a>
  <a href="https://www.netlify.com/">
    <img alt="Netlify" src="https://img.shields.io/badge/Netlify-Deploy-00C7B7?logo=netlify&logoColor=white&style=for-the-badge">
  </a>
  <a href="https://www.cloudflare.com/developer-platform/products/r2/">
    <img alt="Cloudflare R2" src="https://img.shields.io/badge/Cloudflare%20R2-Assets-F38020?logo=cloudflare&style=for-the-badge">
  </a>
  <a href="https://www.jsdelivr.com/">
    <img alt="jsDelivr" src="https://img.shields.io/badge/jsDelivr-CDN-E84D3D?logo=jsdelivr&style=for-the-badge">
  </a>
</p>

📘 This README is also available in [Simplified Chinese / 简体中文](./README.zh-CN.md).

This repository contains the complete source code for my personal blog [Garden of Outlier](https://chlor.me), fully open-sourced on Codeberg and my personal [Forgejo](https://forgejo.org) instance, [MoeForge](https://foss.moe).

## 🛠 Tech Stack

- Framework: [Hugo](https://gohugo.io)
- Theme: [Hermeneutics](https://codeberg.org/chlorine/hugo-theme-hermeneutics)
- Source Hosting: [Codeberg](https://codeberg.org/chlorine/blog) and [Forgejo](https://foss.moe/chlorine/blog)
- Comment System: [Artalk](https://artalk.js.org)
- DNS: [Cloudflare](https://www.cloudflare.com/)
- Hosting: [Netlify](https://www.netlify.com/)
- Backup Hosting: [Vercel](https://www.vercel.com/) and [Cloudflare Pages](https://pages.cloudflare.com/)
- Image Hosting: [Cloudflare R2](https://www.cloudflare.com/developer-platform/products/r2/)
- Static CDN: [jsDelivr](https://www.jsdelivr.com/) and mirrors

## ⚖️ License & Copyright

### 💻 Code

The source code of the Hermeneutics theme is licensed under the MIT License. See the full [LICENSE](https://codeberg.org/chlorine/hugo-theme-hermeneutics/src/branch/main/LICENSE) file for details.

All other code snippets in this blog, unless otherwise specified, are also released under the MIT License.

### 📝 Content

All written content under the `content` directory is distributed under the [CC-BY-NC-SA 4.0](https://creativecommons.org/licenses/by-nc-sa/4.0/) license.

### 🖼️ Images

- Images owned by me are distributed under the same license as the `content`.
- Images sourced from the internet are still being reviewed. All rights belong to their original creators.
- For AI-generated content (e.g. [my avatar](./static/img/avatar.webp)), due to the ambiguous nature of AI copyrights, I cannot guarantee ownership. I disclaim responsibility for any copyright issues arising from their use. Please evaluate the risk yourself. If you believe your copyrighted content has been used, feel free to contact me.