---
slug: weekly-2

summary: 浮生散记第二期
series: 岁时录
tags:
  - 周报
title: Ephemeralis-Weekly（2）：生日快乐
date: 2024-07-08
description: 本文是作者周报的第二期，这是非常值得记录的一周，作者过了自己的19岁生日，并分享了在农历生日和公历生日的庆祝活动。他还提到博客迎来了200天的生日，给博客接入了Quail作为Newsletter，并谈到备案和其他一些想法。
categories: ["人间世"]
featuredImage: https://img.viento.cc/cover/weekly-2-cover.webp
draft: false
---
各位老友们好，我是 Chlorine。

本文为园子周报——Ephemeralis Weekly（浮生散记）的第二期，日期范围为公历 2024 年 7 月 1 日至 7 月 7 日。

这是非常值得记录的一周，祝食用愉快。

## 生日

本周的标题叫作「生日快乐」，很大一部分原因是因为，这周我过了我的 19 岁生日。

我的农历生日是五月廿九，今年的 7 月 4 日；公历生日是 7 月 5 日。很巧。

### 农历生日

按照我家乡的风俗，我喜欢过农历生日。因此，妈妈为我订了一个生日蛋糕，刚好在我下课的时候送来。我送了帮我保管的宿管阿姨一块，留了一块给同宿舍的学长，剩下的，我吃了好几顿。

![生日蛋糕|421](https://img.viento.cc/weekly-2-1.webp "拍照技术不好，见谅")

宿舍不允许用明火，我也没有打火机和火柴，因此我只是把蜡烛插上了蛋糕，没有吹，默默地许了个愿望。生日帽有点短，系不上，被我卡在眼镜下勉强固定住。

我在空空荡荡的宿舍中吃了一大块蛋糕。

### 公历

在旁人眼中，这才是我的生日。

按照班级的传统，每位同学都会有一个生日推。我选了我个人认为最好看的照片，发给了宣委。收到了许多师长、同学和朋友的生日快乐。正巧，我的朋友来学校找我玩，于是说什么也要给我再过一次生日。

![朋友们的蛋糕](https://img.viento.cc/weekly-2-3.webp "蛋糕有些变形了")

谢谢我的朋友们，让我过了一个有人陪的生日。

### 一点碎碎念

在我看来，「生日」和平常的一天，实际上没有什么区别，其所有的特别之处，其实都在于「别人知道今天是我的生日，所以他们会觉得今天特别」。

这实际上是一种外向的认知，将自己的认知依托于别人。一般来说我并不完全赞成这种认知方式，但是由于这次并没有影响到我的 routine，同时朋友和家人的祝福也给我带来了很高的情感收获，所以似乎也不错。

过生日的那个我，和现在在这里不知所云的我，在精神层面应当不是一个我吧。

## 博客 200 天

没错，这周不仅是我的生日，也是博客的 200 天「生日」啊。

一般来说，百天好像会很隆重地庆祝，但是 200 天……我没听过。

反正也是个整数就是了呢。

## 故人来

如上文所述，我高中时代的一位好兄弟过来旅游，希望逛一逛我们的学校。但是平心而论，我这个导游当得极其不称职。没有提前做什么规划，去了许多地方都发现没有开门（例如校史馆），招待也算不上很热情，甚至有几次还没能成功抢单请客。

## 备案

> 打今儿个起，咱也有了旗籍了！

兜兜转转，备案终于是批下来了。实际上也没用几天，办事效率还是可以的。毕竟我这就是一个个人网站，遵纪守法，态度良好，没有不通过的理由不是（Doge）。

据说好多博主不希望备案，是害怕实名信息一查，被人爆了。我还好。

兴高采烈地用了一下 CDN，但是发现问题有点多，罢了，先放着。

ICP 备案之后还有公安备案。为了方便我选的非交互式的，看看后期能不能转交互式，或者直接不管不顾地评论（逃）。

## Quail

最近给博客接入了 Quail 作为 Newsletter，详情见 [Hello，Quail]({{< relref "Hello%EF%BC%8CQuail.md" >}})。

## 其他

口口声声说着「这是值得记录的一周」，但是在笔上却是持之以恒地摆烂呢。

- 想画一些意识形态的拟人，可惜手残，画不了一点，只能口嗨。
- 对开源基金会的运作有一点兴趣。不知道我这个菜鸡有没有机会成立一个真正的开源开发组织呢？
- Windows 11 娘好可爱！>w<
- 当你选择遵循版权法时，生活就会变得艰难许多。
