---
slug: weekly-10

summary: 浮生散记第十期
series: 岁时录
tags:
  - 周报
  - 日常
  - 博客

title: Ephemeralis-Weekly（10）：方寸之外
date: 2024-10-20
description: 本文是作者周报的第十期。文章开头提到本期周报内容较少，作者计划多读书以拓展知识边界。接着，作者详细描述了本周的两场defense（答辩），包括 SRT 的中期报告和奖学金答辩的准备和经历。意外的是，作者的手机掉进了马桶，引发了一系列的处理和反思，包括手机的应急处理和对生活中数字依赖的思考。文章还探讨了在缺失大量智能手机功能的生活状态下，作者反思了数字生活的必要性，并借助了“零基预算”的概念来审视数字工具的使用。最后，作者回答了关于博客的9个问题，涉及博客的起源、创作过程、动力维持、博客运营成本以及个人兴趣和未来计划等方面。
categories: ["人间世"]
featuredImage: https://img.viento.cc/cover/weekly-10-cover.webp
draft: false
---
各位老友们好，我是 Chlorine。新的一期周报，双手奉上。

感觉最近可写的东西蛮少的，周报也越来越短了。看来应该再多读点书，拓展一下知识的边界了。Obsidian 的那篇文章还在写……到底还要鸽多久啊 qaq

同时，周报的标题与文章内容相关，但是小氯并不会对其关系做出详细解释。

本文为园子周报——Ephemeralis Weekly（浮生散记）的第十期，日期范围为西历 2024 年 10 月 14 日至 10 月 20 日。祝食用愉快。

## Week of Defense

由于当今网络中一些小氯并不算喜欢的以中文谐音为方式的迷因，现在小氯通常不会使用「答辩」，而是使用「defense」。

小氯这周比较忙，有两场 defense，一场是 SRT 的中期报告会，另一场是院里的奖学金答辩。相信老友们应该没什么兴趣听小氯讲 SRT 的专业知识或者再做一场赛博奖学金 defense，所以咱们就长话短说吧。

SRT 的中期报告会很早就在通知了，然而小氯一直在摆烂，结果就是硬生生把中期报告拖到了离 DDL 一周以内。这下如果真不写就要趋势了，于是小氯只好咬着牙开始写（bian）。所幸也不需要写得太复杂，简单交代下项目进展就好。反正小氯没像那些大佬一样做海报，只是交一份报告。

而奖学金的 defense 相对复杂点，不过也就是传统的单人 pre 形式，类似面试。小氯成功在挑选 PPT 模板上花费了几个小时（选综 qaq），最终也是卡着 DDL 把 PPT 交上去了。

中期报告会和奖学金 defense 的时间很近，基本上是挨着的。小氯也没做什么太多的准备，熟悉了一下稿子，穿上正装就走了（小氯在做 defense 时喜欢穿正装，这不仅显得正式，而且可以大大强化战斗力，应该是心理效应 OωO）。

中期报告会比想象中简单很多。小氯几乎什么也没做（如上文所说，小氯没有选择做海报），主要是在给大佬们投票。最后也是很顺利地过了。

下面就是奖学金了。小氯自认为做 pre 的功夫非常到家，效果应该也是所有 defenser 中最好的一批。奈何一起参加的同学们都是中华超人，人家一点技巧也不讲，主打一个纯粹的力量美。算了，随缘吧 qaq

## （前方高能）

> [!WARNING]
> 以下内容不适合在您以任何形式摄入任何对您生命维持或情感体验有益的实体时观看！

事情是这样的。那天小氯还在准备报告会和奖学金 defense。由于高强度的体力和脑力劳动，小氯的身体和精神状态都不太稳定。写到一半，实在是太累了，小氯就回宿舍喝了口水，顺便去解了个手。

然后……

然后……

然后……小氯的 iPhone，就掉到了马桶里……

然后……小氯……无意识地用手把 iPhone 捞了出来……

啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊！（发出尖锐爆鸣）（冒气泡）（扩散）（光解）（形成自由基）（抱着小氢燃烧）（发出苍白色火焰）（液化）（疯狂流动）

~~小氢：你先去洗手啊！~~

如各位所见，小氯是有点洁癖的（~~不然也不会形成次氯酸钠这种东西~~），所以虽然实际上这个和掉到泥水里面差不了太多，但是小氯当场就红温了。

然后嘛，就是拿着酒精湿巾和湿巾反反复复地擦，然后把一切碰到的东西都消了一遍毒，然后洗了不下二十遍手……

~~期间小氯甚至差点把 84 消毒液倒到自己手上~~

然后小氯才想起一个严肃的问题：手机进水，这不是什么小事，而小氯刚才只顾着清洁，完全没注意这点。

然而小氯既没有大米也没有硅胶，因此暂时只能采取风扇加冷处理方式。

等了一晚上。第二天打开，似乎没事，但是充电时似乎不太对劲，比较慢。这说明充电口里可能有水。

不过此时小氯已经要去上 ODE 了，于是小氯斥巨资 30r 网购了一份硅胶干燥剂和自封袋，然后再次把手机关机。

回到宿舍后，干燥剂已经送到了。为了省钱，小氯买了一堆小包装。于是小氯戴上一次性手套，剪了一大堆小包装，做了一个填满一半的干燥袋，然后把手机包了几层，放了进去。

![|598](https://img.viento.cc/IMG-20241019171008.avif "大概是这样")

然后大概过了 48 个小时，小氯把手机拿了出来，然后就该如何用就如何用了。

目前来看似乎没遇到什么问题，除了投送 opus 的时候会失败，但是我怀疑这可能是牢果的 bug。

## Live without a Phone?

本节实际上有点标题党，更准确的说法是「Live almost without a Phone?」。

如前面所说，由于一次灾难性的意外，小氯的 iPhone 暂时无法使用了。于是小氯只能暂时使用自己的备用机。

小氯的备用机是什么情况呢？就是小氯以前的手机。配置倒是不低，但是在不用以后就开始卡顿，不知道为什么。手机里面没有手机卡，没有各种各样的软件（比如 B 站、饿了么、美团，就连我电动车的解锁软件都没有）。微信、输入法等都维持在能用就行的程度。于是小氯这个重度电子产品依赖就拿着这个手机过了好几天。

不方便吗？那是自然的。在离开 Wi-Fi 覆盖区域后，没有流量，上不了网，甚至电话都打不了，完全和现代通讯网络断绝联系；开电动车需要用钥匙拧，往往需要拧好几次才能打开；想点份外卖时发现没有外卖软件，有也没法登录，只好咬牙前去食堂排队；想看看邮件和 Twikoo 评论通知，然后想起来没有飞书，于是只好等到达预定地点后打开电脑；Fcitx5 打字体验实在是令人一言难尽……

**但是，小氯怎么样了吗？**

显然，答案是没有。经历了几天堪称互联网原始人的生活后，小氯似乎也并没有自挂东南枝（~~为什么要用「似乎」？~~），反而因为不能刷 B 站、时时刻刻看微信而精神清明了不少。

---

在会计学中有一个概念，叫作「零基预算」（Zero-Based Budgeting，简称 ZBB）。其大概的思想就是：在新的预算周期，并不根据前一年或几年的预算来制定新的预算，而是从零开始，一项一项考查每一笔费用。

各位老友可以试想一下：如果为各位的数字生活做一个「零基预算」，且要求预算尽可能低，各位会选择留下什么？

现在至少在手机的层面，小氯已经有一定的认识了。小氯不在此展开对哪些功能必须保留或者建议保留的具体论述，但是有一点可以肯定——**小氯实际需要的，比小氯从前以为自己需要的少得多**。那些「德不配位」却依然食尽皇家千钟粟的软件和功能，或是一种「指不定哪天就用上了」的过度备灾，或是华而不实基本上只能起到自我陶醉作用的「工作流」，或是对低级、碎片化快感的贪恋。如今，也是时候拨乱反正、捧日柱天了。

——于是，在回到原本的 iPhone 之后，小氯光速对手机上的软件进行了大规模的断舍离。唯一逃脱掉的软件是 QQ，虽然说小氯对 QQ 没有任何形式的好感（比微信的印象还要负面）。

在未来，小氯可能会更多地做一些这样的 digital detox（姑且使用这个词），而且方式可能会更极端。这不是什么新奇的事情或者独特的哲学顿悟，只是一个~~元素娘~~原子终于明白了一点早应该明白的事情而已。

## 关于园子的 9 个问题

和上一期一样，这依然是一个问卷，来自 [Another Dayu](https://anotherdayu.com/2024/5962)。

### 简单介绍下自己或者你的博客？

「Garden of Outlier」，你可以叫它「园子」。茫茫的信息海洋中的一个草木葳蕤的角落。

园子里住着这么一个智慧体，你可以称其为 Chlorine，或者是小氯，或者是小氯酱，或者是任何你觉得合适的变体。这是现实中的 Chlorine 在园子里的一个投影，或者是一个 speaker。你可以把小氯当成现实中的~~废柴~~大学生，也可以当成一只很萌的元素娘，也可以当成一个被捏成这样的人工智能，或者干脆就当成一个会讲故事的原子也行——随意。

小氯时不时会在园子里露个面，修剪一下长出的杂草，或者是小心翼翼地移栽一株培育好的新植物，或者是做一点装修的工作，或者是和宿管同志们一起改进一下 Residencia 0x001B 内的采光情况，或者是和食堂的师傅们一起研究下最近应该出什么新菜……更多的时候，只是坐在公寓阳光灿烂的公共空间，手边放着一杯刚刚泡好的茶或者果茶，随意地看看书，或者是写写代码，或者是发发呆。

尊敬的旅行者，如果您路过这座小岛，又恰好感到有些疲惫，不妨就在此处驻足停留一会儿吧。去找小氯喝一杯热茶，吃一些点心，听上一两个故事，然后再踏上自己的旅程吧。我无法保证您一定会喜欢这里，但在下着雨的秋夜喝杯热茶，怎么说大概都算不上一件坏事。

### 什么契机让你开始写博客？

说来话长。

小氯第一个接触的独立博客是[夜猫日记](https://lillianwho.com)（现名 Lillian Who）。在这之前，小氯甚至都不知道什么是独立博客。从这里，小氯知道了 Hugo，知道了 Gridea，知道了其他的一些东西。大概就是从那时开始，小氯觉得，有一个自己的 cyberspace，似乎是一件不错的事情。

然而，对于一个（在当时）计算机知识极度匮乏，并且还对博客的各方面有一定要求的用户，搭出一个自己喜欢的博客，简直难如登天。个中曲折，小氯不在此细说了。很幸运，最后小氯发现了 NotionNext，这个简易、精美且强大的框架。然后呢，从 NotionNext 到 Hugo，从 Hello Friend 到 Virgo 到 Blowfish 到 Efímero 再到 Hermeneutics，小氯在装修园子这件事上一去不回。而在不断的折腾中，使用文字记录生活，在园子里种上一株又一株植物，似乎也成了生活的一部分。

「搭建博客」和「用文字公开地记录生活」是两个不同的概念。对小氯来说，是前者更先进入小氯的世界。

### 你是如何完成创作的？

大概分为以下步骤：

1. 想到一个话题，在手边任何可用的载体（例如 Memos，Apple 备忘录，微信文件传输助手，纸）上记一下。
2. 在 Obsidian 新建一个文件，然后闲着没事就想这个话题，把一切能想到的东西都写到文件里面。
3. 泡一壶果茶。
4. 找一个完整的时间段，开始把碎片化的思维整理成完整的文字。
5. 执行发布脚本。
6. Git Commit & Push。
7. Vercel CI/CD。

### 运营博客的过程中是否有失去过动力？

首先请容小氯吐槽下，这个问题实在是太长了。其原问题为「运营博客的过程中是否有失去过动力？如果有，是为什么恢复的？如果没有，请问您又是如何保持创作的激情？」。

当然有，大体原因还是老生常谈的那些，就是太冷清了，没有什么反馈，动力自然会衰减。此外还有个原因，就是当时的小氯还没有对互联网上的自己和博客形成一个完整的身份认同和叙事塑造（听不懂也没关系，这个事情我暂时也说不太明白）。

至于如何恢复，很大可能是小氯性格使然。小氯是个内驱力非常强烈的人，一旦自己觉得一件事情有意义，那么不管周围环境如何，都会持之以恒地做。

### 如何搭建博客，以及运营博客每年需要投入的资金？

~~第一步，选定一个框架；第二步，购买或者注册相应的资源平台；第三步，搭建好你的博客；第四步，开写。~~

小氯曾经写过一个系列《Obsidian + Hugo 建站教程》。然而由于内容早已跟不上园子发展的速度，而且实在是有洗稿的嫌疑，因此被我光明正大地鸽掉了。

目前为止，与园子直接相关的会计成本为 75r/a，即域名的资金。

### 推荐 1 篇你博客中的文章，并推荐一个你喜欢读的博客，聊聊原因。

小氯没觉得有哪篇文章写得特别好的，如果一定要推荐，那还是[这篇周报]({{< relref "Ephemeralis-Weekly（8）：七日漫谈.md" >}})吧。

小氯有很多「喜欢去」的博客，但是「喜欢去」和「喜欢读」并不完全一样。而且，「博客」和「个人网站」和「个人文字作品展示网站」和其他的许多概念并不是一回事。举一个非常有名的例子：阮一峰老师的博客。小氯不清楚阮一峰老师过去的博客是什么样的，但是至少就现在而言，阮老师的博客更像是一本**电子杂志**。你可以从阮老师每周一更的周刊中获取到许多有用的信息，也能感受到阮老师丰富的知识、广博的阅历和编写周刊的用心认真，也偶尔可以从一些字句中窥见阮老师的思想和好恶。**但是，你不能从周刊中看出来，阮老师具体是一个什么样的人**。在小氯看来，这实在是太正常了，因为，就如[极客死亡计划](https://www.geedea.pro)的作者 Eltrac 写下的：

> 我和「极客死亡计划」更像是创作者和作品的关系，作品本身尽管会反映作者的个性，但并不会明目张胆地把自己整个人写满在自己的创作上（就算是畅销书，书页里也只有一句话的作者简介）。所以，关于我是什么样的人，在这里不会多说，如果你感兴趣，我希望你能读一读我写的东西。

偏向「文字作品集」的个人网站，会更多地致力于让你通过文字，了解创作者的思想、见地和情感，创作者本身只是一个（甚至有时候无关紧要的）信源；而偏向「个人博客」的个人网站，会更多地致力于让你了解创作者本身，文字只是其最主要的手段。当然，这些类型的网站并无高下之分，其界限也并不分明——世界上本就不存在什么绝对的分野。

就园子而言，小氯对其的定位更加偏向后者。我希望当老友们读着这些营养价值不高的文字的时候，真的感到就像有那么一只端着热茶、眉眼弯弯的小氯，坐在赛博空间里的你对面，用轻松随意的语气讲着一个一个故事。你能透过氤氲的雾气，看到对面人的一举一动。来的次数多了之后，你甚至能知道他/她/它喜欢什么颜色的衣服，到深夜几点时会满脸疲倦困得不能自已，在往二食堂新鲜出炉的面包上抹同样新鲜的果酱时喜欢从哪一边开始仔仔细细地涂，听到哪一句名言会突然笑得不能自已，或者是突然开始正襟危坐，严肃地发表自己的看法——总而言之，就像一个生活中与你相知甚久、无比熟悉的老友一样。

当然，这需要无比生动的细节和高超的表现技巧。小氯自问暂时还做不到这样。

有点跑题了，咱们回来。如果要寻找一个小氯喜欢读（不是「喜欢去」）的「博客」，那这是个很难的事情：尽管小氯的拜访名单并不短，而且其中许多博客都非常优秀，但是如果你需要的是那种每次读完之后都有「须臾收卷复把酒，如见万里烟尘清」的快感或者是「Leave me thinking」的深沉的博客，很抱歉，小氯一时半会没能想到。

答这套卷时，小氯一直是凭借第一感觉在作答。既然一时半会没能想到，那么就证明还没有一个（至少是对小氯）堪称 silver bullet 的答案。更何况，「推荐博客」这种事，是非常严肃的，找一个并不完美的答案，是一个完美主义者无法接受的。

小氯知道，上面的理由用来为本小问空缺辩护并不足够充分，这里算是小氯强词夺理了吧。

### 推荐 1 个近期喜欢的事物？

Rust！Cargo 真的很好用 www

### 想做还没有做的事，或想尝试还没有尝试的主题？

Rust（正在学），Go，TypeScript，Vue，React，Next，Tauri，Kotlin，Swift，Dart，Lua，Python（认真学），Docker，Kubernetes，密码学，网络安全，区块链，去中心化技术，智能合约技术，西方哲学，系统科学（认真学），世界历史，马克思主义理论（正在学），西班牙语（认真学），传染病学和流行病学，危寄坟（复（yu）习），线 die（复（yu）习），离散数学（复（yu）习），数理统计（认真学）……

小氯是个什么都想学一点的杂食原子  OωO

### 写任何你想写的东西。

这个问题的完整表述是「写到这里，闭上你的眼睛，深呼吸几分钟，或是出去溜达一圈，然后回来写任何你想写的东西」。

……

本诗的创作部分求助了 AI。小氯的文学功底不够，因此如有文法不通、含义怪异、佶屈聱牙之处，烦请各位老友海涵。

> Of vivid scenes, I cannot paint,  
> nor sing with heaven’s grace.  
> So I stitched with bits and numbers,  
> weaving an absurd self—  
> 
> lines knotted like thoughts,  
> logic spiraling into echoes,  
> a digital soliloquy unraveling,  
> where reality fractures into fragments.  
> 
> Here, I am a phantom of functions,  
> a mosaic of misplaced syntax,  
> my colors, zeros and ones—  
> my voice, the hum of machines.
