---
title: Ephemeralis-Weekly（13）：生活的起伏
date: 2024-11-24
summary: 浮生散记第十三期
description: 本文是作者周报的第十三期。文章开篇，作者承认自己情绪存在波动，具体可以从不同的部分看出变化。作者提到为个人博客购买了新域名 `chloryn.com`，并详细阐述了选择这个域名的理由和过程。接着，作者讨论了“自设”的概念，并诙谐地表达自己无力创作视觉自设的无奈。在生活方面，作者描述了申请中行Mastercard信用卡的经历，还分享了一封遭遇勒索邮件的经历，并指出这类邮件只是毫无根据的恐吓，不应理会。技术方面，作者首次尝试刷机，将一台旧的小米 CC 9 手机刷成 LineageOS。此外，作者提到购买了新的 VPS，用于网站服务的部署。最后，作者以自己在宿舍中重拾睡前喝热牛奶的习惯为结尾，以平和的口吻描述了这种简单日常为其带来的宁静与满足感。
categories: ["人间世"]
series: 岁时录
tags:
  - 博客
  - 周报
  - VPS
  - 域名
  - 日常
slug: weekly-13
featuredImage: https://img.viento.cc/cover/weekly-13-cover.webp
draft: false
---

各位老友们好，我是 Chlorine。很抱歉因为个人的情绪波动和生活状态问题落下了一期周报。

这半个月小氯遇到了许多事情（~~但是长度还是比较短~~），经历了从颓废到宁静和充实再到极度焦虑再到略为缓解的多次起伏。个中原因小氯不希望多说，但是各位老友应该能从我文字风格的变化窥见一二。《热牛奶》那一章是我精神最安宁的时候写下的，而最近更新的 now 页面则是我最焦虑的时候写的。本期的标题也体现了这一状态（以及本期应该是第一期副标题不是四个字的周报？虽说对强迫症的老友不太友好吧，但是也跳出了一层文字的限制）。

以及，本周没有什么哲学，请放心观看 (/ω＼)

本文为园子周报——Ephemeralis Weekly（浮生散记）的第十三期，日期范围为公历 2024 年 11 月 11 日至 11 月 24 日。祝食用愉快。

## 新域名……应该是几来着？

~~现在买个域名已经不值得让小氯单独写篇文章了~~

这次是对[上一期周报的纠结]({{< relref "Ephemeralis-Weekly（12）：浮沫之下.md" >}})的解答，苦思冥想了很久才想到一个比较好的、和 Chlorine 相关的域名：`chloryn.com`。

这个词读音很像 Chlorine，但是看起来并不是个很常见的英语词汇，如果非要说的话，带一点斯拉夫风格。所以还是让小氯解释下这个前缀是怎么来的吧。

其实小氯本来想用一个 Clori（小氯的西语名字，Cloro 的变体，Clorito 和 Clorita 的合并简写）的变体，但是实际上，小氯极少使用这个名字，平时所用的英语名字要么是 Chlorine，要么是拼音版本的名字（将来正式的英文名）。而且 Clori 看起来也并不容易让人想到 Chlorine。而加单词的变体，例如 `hichlorine` 或者 `chlorineworld` 之类的，又实在是太长了。

那么我们的选择就比较明显了，就是对 Chlorine 进行一些不改变（太多）读音和基本字形的变体。一些常见的选择包括：

- chlorin：读音几乎不变，但是你猜我为什么不用……
- chlorino / chlorina：一个男性化 / 女性化的名字，很有西语的风范。
- chloris：古希腊神话里的花神（~~纳西妲？~~），和 Chlorine 的词根一致，具有强烈的女性化色彩。

很遗憾，这样的前缀用核外电子都能想到很抢手，那么很显然，常见的选择已经无法满足小氯的需求了（~~你今天废话怎么这么多？~~）。

于是，小氯发挥了传统艺能——问 AI。在 AI 给的一大堆选择中，小氯注意到了一个词：chloriny。

众所周知，i 和 y 的读音在很多时候都是相似的，那么如果用 y 替换掉中间的 i 呢？然后去掉不发音的 e，就有了一个更简单的域名前缀——chloryn。

`-ryn` 这个后缀并不是个常见的选择，因此不需要担心会不会出现品牌冲突和占用，而且也比较短和容易发音。最重要的是：它可用。所以，剁手吧。

依然是在 Spaceship 买的，不过由于用了一个 promo code `COMPROS`，直接把价格打到了不到 3 USD，确实太夸张了。继续挂到大善人 Cloudflare 上。

小氯还是挺喜欢这个域名的，后续可能也会考虑备案（涉及到转到一次套路云，外国公司应该没有域名所有权证书可以用）。应该在不太远的未来，园子就会换域名了。

~~冷知识：小氯这周还买了个 `herex.icu`~~

顺便再吐槽一句，现在域名续费是越来越贵了，套路云的 `.com` 域名都要 90 了……该把那些不用的域名放掉了 qaq

## 画个自设？

我们事先声明下，下文的「自设」都是指「自我设定」。因为据我的查找，广义上任何原创的设定都可以叫自设。

对于二次元文化圈来说，自设应该是一个近于必需品级别的存在（这是我根据周围的小样本概括得出的概念，不一定泛用）。虽说小氯并不是二次元文化爱好者（认为二次元风格的图片具有视觉吸引力的人群应该是远广于我们所说的「二次元」的），但自设也是个很好玩的事情，和我平时设计小说角色和世界架构一样好玩。

很可惜，自设一般是视觉形象，而如各位老友所见，小氯在任何形式的绘画方面都毫无天赋，不论是纸绘，板绘甚至是和传统绘画都没什么关系的 AI 绘画。

而且，小氯也不希望过多地局限各位老友对小氯虚拟形象的印象。引用我在[回答 Dayu 的博客问卷时]({{< relref "Ephemeralis-Weekly（10）：方寸之外.md" >}})的话：

> 你可以把小氯当成现实中的某神秘高校大学生，也可以当成一只很萌的元素娘，也可以当成一个被捏成这样的人工智能，或者干脆就当成一个会讲故事的原子也行——随意。

「——那你侧边栏放的那个是什么？」

好问题。虽然小氯侧边栏的头像（也是当前小氯在许多平台使用的头像）确实很容易被认为是小氯的自设，尤其是其还和现实中的小氯有很多细节上的相似（例如 MacBook，果茶，抓着杯子时一般有一只手只用三根手指卡住），但是这确实不是。这张图的来历大致是小氯突发奇想捏了一些 prompt 然后丢给了豆包 AI，然后就炼出来了这个。最多只能说是一个很初步的视觉草稿吧（注：小氯最近换头像了，这段话的原型图片是[这张](https://img.viento.cc/chlorine-juice-safer.avif)。

甚至现在连文字版的自设都没写好——没错，小氯对于自己的事情也总是那么倦怠~~这和你活泼非金属的身份不符啊~~。这也造成拜托一位画师来代绘的难度极高（~~而且小氯写的那些幼稚的东西给画师看真的不会社死嘛~~）。

## Mastercard 信用卡

小氯很早就想办一张境外的银行卡了，毕竟现在很多操作都需要付 USD，有一些羊毛（比如 Amazon Cloud 的免费服务器）也需要绑卡才能薅到。更不用提小氯将来还有出境旅行的计划。

小氯关注了不少可能能薅到的虚拟银行卡，很可惜，它们都有一定的开卡费（虽然说也不多），而且毕竟也不算是什么正规渠道，容易出问题。于是小氯就盯上了国内银行的外币卡或者双（多）币卡。

小氯也收集了很多这方面的信息，最终锁定了两张卡，一张是工行的星座卡（0 额度信用卡），一张是中行的 Mastercard 卡（借记卡）。小氯不在乎是 Visa 还是 Mastercard，不过由于小氯已经有一张中行的卡了，所以就想着搞一张工行的卡。

很不幸，小氯线上申请了两次，都被拒绝了，原因未知。~~或许是宇宙第一大行不喜欢小氯吧。~~

于是小氯开始打听中行 Mastercard 的办理方法，得知只需要找最近的、能办理跨境金融的网点，有卡板就可以办理。

那最近的、能办理跨境金融的网点在哪里呢？

答案是：在小氯的宿舍旁边。

没想到吧（笑）。

由于电话没打通，于是小氯趁着上大物之前的空隙直接去了网点。

然后……小氯得知，网点办不了借记卡，但是可以办 Mastercard 的信用卡（当然是 0 额度）。

也好。花起来和借记卡一样，顺便也能积累下信用。唯一的遗憾大概就是卡面很普通，不如 Mastercard 借记卡的卡面那么好看（没错，我指的是那个非人哉的联名卡 (/ω＼)）。

办的过程几乎没什么可讲的，全程没遇到任何麻烦。唯一值得讲的就是小氯在填家庭住址时，大堂经理满脸惊奇地说，听不出你有任何口音（小氯家乡的方言确实以口音明显知名）。然后就等着卡邮过来再去激活就好了。

当然，既然是信用卡，就会涉及年费的问题。这张卡的年费是 200r，但是首年免年费，每年消费五次可以免次年的年费，那基本就相当于没有了。每年我往校园卡里面充几次饭钱，每次一 CNY 就好了（你别说，校园卡真的可以一次充一元钱）。

这张卡是 Mastercard 和银联的双重卡，在大陆和海外都可以使用。CNY 和 USD 账户是分开的，消费需要通过购买外汇进行充值。还好小氯有一张一类卡，购买外汇是没问题的。只是小氯有点好奇，这样的卡能用来绑定 Amazon 和 Oracle 这样的服务吗？

以及最近开始对各种各样的银行卡感兴趣了。也不仅仅是觉得一些卡面比较精致吧，感觉随着了解到的事情越来越多，某些生活方式却变得越来越旧式了。

## 一封勒索邮件

下面的事件可能会让人感到不适，但是确实是真实地发生在小氯身上的。

事情的起因是，小氯闲着没事翻自己的 Tutamail 的时候，突然看到了垃圾邮件里面有一封奇怪的邮件。好奇心驱使着我点开看了下，结果是开幕雷击：

>  Good day.
>  
>  Your system has been hacked with a Trojan virus.

带着满脸的问号，小氯大致看完了整封邮件。由于相关法律法规限制，小氯不能完整地展示邮件内容。简单来说，发邮件的人声称已经完全控制了我的个人电脑，并且拿到了一些关于我的不适宜公开说明的内容，然后要求我使用加密货币向他转一笔钱，否则就把这些内容公之于众。

说实话小氯看完之后的表情大概是：

![|500](https://img.viento.cc/emoji/EMJ-confused.webp "黑人问号.webp")

这显然是一封毫无意义的勒索邮件，因为他拿不出任何证据支持他的说法，最重要的是小氯从来没做过他说的事情。由于小氯注册 Tutamail 的时机比较合适，因此拿到了一个不错的前缀，很可能是我的邮箱被猜到了。

遇到这种事情，正确的处理方法是什么都不做。无论是任何的动作都会证实这是一个活跃的电子邮件地址，从而招致更多的麻烦。而且，对于这群只会躲在 VPN、匿名通信和区块链后面的懦夫来说，你也没办法对他们怎么样。

这件事情没有给小氯带来任何的现实损失，除了浪费了我五分钟时间看他们胡编乱造的邮件。不过从情感上，这很令人不愉快，有点像苍蝇落在你身上的感觉。

这可能也证实了小氯从前说的一个观点，最小化但必要的监管对于去中心化的互联网必不可少。至少对于这群勒索者，他们需要一点监管的铁拳。

## Hello，LineageOS

> 来来来！全体目光向我看齐！看我看我！我宣布个事！我会刷机了！

没错，就在今天，小氯完成了人生中第一次刷机 ヾ(≧∇≦*)ゝ

TL; DR：把一台很旧的小米 CC 9 刷了 LineageOS，体验良好，但是没有测试国产软件。

### 前言

如各位老友所见，小氯一向对国产的 modified-Android 颇有微词，甚至还曾经在周报里非常失态地激烈指责过 ColorOS（请见[上一期周报]({{< relref "Ephemeralis-Weekly（12）：浮沫之下.md" >}})）。情绪本身是会自我发酵的，尤其是负面情绪。所以在对 ColorOS 的不满积累到一定程度后，小氯决定向 OPPO 国开战（慈禧音），方法就是刷一个原生安卓，证明我没有你也能活得很好（~~真是个幼稚鬼~~）。

当然，指望用 OPPO 刷机，还不如指望慈父同志养猫（~~你别说还真可以用 mod 给他送一只~~）。比较好的是，小氯的家里有一些废旧手机，只需要让我亲爱的娘亲邮寄一台即可。

手机很快到了。是一台 Mi CC 9，6+128 的旧配置，MIUI 12。很幸运，德高望重的 LineageOS 对于这个型号有很好的支持。

### 换 SIM 卡

开开心心地打开开发者选项，然后 enable USB debug……怎么启动不了？哦，需要 SIM 卡。

小氯当然有 SIM 卡，只需要换一张进去就可以。然而……小氯不会换 SIM 卡（捂脸）。

所幸这件事倒也不难，找个视频学学就好。小氯没找到卡针，于是用了绣花针（~~不要问小氯为什么会有绣花针~~）和顶针。好笑的是，小氯的第一张卡是放不进这台旧手机里的，但是第二张卡可以，确实有点奇怪。

### 解锁 BL

刷机的第一步当然是解锁 Bootloader。MIUI 的 BL 解锁相当容易，而且由于这台手机太老了，也不涉及等待的问题，因此在手机绑定账号之后使用小米助手即可。

小米官方的刷机助手不能在 macOS 使用，所幸社区制作了一个替代品。下载之后选择允许运行，然后一点就可以了。

注意 BL 解锁后手机会直接重置，因此需要重新打开开发者选项、USB 调试这些。

### 刷入 Recovery 和 ROM

按照官方的指导，我们可以先刷入 Recovery，然后通过 Recovery 刷入 ROM。这个步骤教程里面讲得很清楚，可惜小氯踩了一些坑：

- 刷入了损坏的 Recovery，原因是中国科大的镜像把我的浏览器拦截掉了。解决方法是 `wget`，又稳又快。
- 刷入 Recovery 之后直接重启手机导致白刷了。正确方法是看到 LineageOS 的 Rec 界面后把手机放在一边等待后续操作。

具体操作可以去看 LineageOS 的操作指南，讲得已经很清楚了，小氯没必要在此赘述。

### 完结撒花

然后启动手机，就可以享受丝滑的 LineageOS 体验了。不得不说，LineageOS 是真的好用，不仅资源占用低（至少不卡了），而且也足够自由。

感觉刷机也不算太难，感觉已经可以考虑入一台 OnePlus 11 刷下当作备用机乃至主力机了。只是不知道对一些国产软件的压制如何。之前听过用「炼妖壶」来制造隔离环境，但是这样还能做到照片分享之类的吗？

## New VPS

[之前曾经说]({{< relref "Ephemeralis-Weekly（12）：浮沫之下.md" >}})我买了人生中第一台 VPS，是 Cloudcone 的，然后光速把它销了。然而小氯这周又买了一台 VPS（

这次同样是小有名气的品牌，RackNerd。BF 特惠机型，配置大概是：

- 2 vCPU Cores
- 40 GB PURE SSD RAID-10 Storage
- 2.5 GB RAM
- 3000GB Monthly Premium Bandwidth
- 1Gbps Public Network Port

这次的配置终于够用了，别说是 Docker，1Panel 都绰绰有余了。价格大概是 19 USD / a，还算实惠。

本来因为最近网络环境的一些波动，小氯打算拿来做一些网络安全方面的学习和研究，但是想想还是算了吧，太浪费了。目前大概是准备把 HereX（园子的服务系统）的一些东西部署到上面。

目前为止大概有四台服务器了，可以部署一个监控面板。只不过，部署在我的主虚拟机的面板没办法连通到其他机器，不知道是否和它是纯 IPv6 的有关。

## 新的订阅服务？

订阅服务是园子翻新计划的重要部分，小氯打算构建一个最小化且足够好的订阅系统，使得希望订阅的老友们能选择自己最喜欢的途径。~~尽管愿意听小氯碎碎念的老友应该也不多。~~

订阅服务大体上也就分三种：

- RSS / JSON Feed
- Email Newsletter
- Instant Notification

园子现在的 RSS 已经比较完善了，JSON Feed 的建立应该也不难，因此我们就不说了。

### Newsletter

Newsletter，脱胎于过去的杂志或者报纸的订阅（邮箱——电子邮箱，不是吗？），这本身就给人一种很旧式的感觉。就像是在圣诞节后的长假中，落着大雪的冬日上午，壁炉中烧着柴火，噼啪作响。站起身来，裹上自己的外套去大门口的邮箱里取新一期的杂志或者报纸。想着回来后可以喝到热巧克力，便先冲好一杯放在壁炉旁。冬日的阳光透过薄薄的云层，洒在积雪上，泛着柔和的光芒。眼镜上凝结出细密的水珠，新买的雪地靴踩在花园小径尚未完全清扫干净的积雪上，发出咯吱咯吱的响声。将尚带着油墨香的印刷品放进自己的怀里，裹紧了自己的外衣。空气冷冽而清新，温暖的哈气悄无声息地消散开来。

……抱歉，遐想得有点多。Newsletter 本来是一种定期发送的邮件订阅，但是由于现在的许多作者偏好于每次更新都通知一下，而且，除非是只更新周报，否则在每周统一更新一次的技术难度恐怕比较高。

小氯原本的订阅使用的是 Quail，现在打算使用一个邮件订阅的 API，进行自动化的发送。目前看来最可靠的应该是 AWS，但是小氯没有使用 EC2，因此需要支付费用。虽然也没几个钱，但小氯还是希望找一个更合算的 alternative。

### Instant Noti

由于可达性和自由性等问题，小氯不会考虑 Twitter 和 Telegram Channel。此外为了订阅者的隐私考虑，也不考虑群聊或者房间性通知，如 QQ 群和 Matrix Room 等。

#### WeChat Official Accounts Platform

尽管小氯并不喜欢某绿色聊天软件，但是不得不承认，对于大部分用户，WOAP 都是一个非常方便的选择。WOAP 也没有规定文章不能发摘要。但是很不幸，WOAP 并没有方便的 API 可以进行调用。

#### Fedibot Feed

这个词不太常见，简单来说就是注册一个 Fediverse——准确来说，这里说的是 ActivityPub 的机器人账户，然后通过这个账户发送更新通知。

这是个相当有趣的方式，由于 Mastodon 等 ActivityPub 的实现一般都提供 API，也可以实现高程度自动化。问题是去哪里注册机器人账户。Fedi 确实有一些 bot-friendly 的实例，比如 <https://botsin.space> 和 <https://mastodon.bot>，然而访问不算通畅（我的自动化节点在国内）。而在一般的实例部署 bot，总归有点滥用的嫌疑。

那看来自己部署一个应该是最好的选择了，小氯新买的 VPS 就打算拿来做这个。Mastodon 太重，Misskey 太二次元，感觉 Sharkey、Akkoma 和 GoToSocial 不错。小氯最喜欢的还是 GoToSocial，奈何这货的默认界面实在是太难看了，如果要改的话，需要折腾整个 `web` 文件夹的布局和样式文件，工作量实在是挺可怕的。

## 热牛奶

小氯曾经有一个持续很多年的习惯：睡前喝一杯热牛奶。这个习惯是我的原生家庭培养的诸多习惯之一（其他的习惯包括早睡早起、早餐吃一个鸡蛋、长期坚持学英语、饭后散步等）。只是因为上大学后生活作息在一定程度上被打乱，所以这个习惯就丢下了。

如前文所说，小氯这段时间身体不太舒服，于是为了感觉好一点以及睡个好觉，小氯又想到了这个办法，于是在某外卖软件上下单了一小箱牛奶。

如各位老友所见，宿舍不允许使用炊具，这当然也包括电热棒。所幸，在零层大厅中有一台爱心微波炉。一般来说热牛奶适合在睡前半小时到一小时喝，那么对小氯来说就是晚上十点到十点半之间。今天的这时候，我正好写 Bomblab 的报告有些疲倦了，顺道可以下去活动一下。

衣服也不需要换了，身上的睡衣就好，毕竟楼内并不冷。小心翼翼地拿着盛满牛奶的杯子走进电梯——小氯只有一个杯子，或许应该再买一个用来喝牛奶的杯子的，毕竟每次要把水杯刷干净真的很麻烦——常喝牛奶的老友应该知道，如果盛放完牛奶的水杯不刷干净，过一段时间会发出非常难闻的味道。

胡思乱想着，电梯到大厅了。微波炉平时用的人不多，晚上更是如此。火力不太知道调什么，先调一个中火两分钟试一下。等待的时间偶然抬头，看到微波炉上面有一张海报——原来，这个「爱心」不仅是这台微波炉可以无偿地被全楼的同学使用，也是因为某个爱心社团通过微波炉发起的希望工程小额募捐行动。很遗憾，小氯今天没带手机，等到明天补上好了。

奶热好了。很遗憾，这个火力和时长只能把奶变温，远远不能变热。那就调到高火，再加热一分钟试试。旁边的保安师傅看了我一眼，但是没有任何反应。小氯和楼里的三位保安师傅都蛮熟的，尤其是下午值班的那位。

微波炉又停了。这次的温度很好，足够热但是并不烫到难以入口。看来以后大概用高火加热一分到一分半就好。还是不要等到回寝室了，这样可能会凉。不知道偶尔路过的同学看到小氯一边走一边时不时低下头喝一口牛奶会不会觉得好玩。

回到宿舍，牛奶还剩一大半，正好一边喝，一边把这些字敲出来。剩下的报告等到明天上午再写吧，DDL 还有一周呢。

键盘噼里啪啦地响着。MacBook 的键盘手感一直很合我的胃口，不过如果键程再长一点就好了，这样应该不会有那么强的撞击感了。

奶喝完了，这些字也要敲完了。时间大概是晚上十一点，下面去洗一洗水杯，刷牙睡觉吧。

感觉心情非常平静，大概是牛奶的功劳吧——我记得高中学过，牛奶富含色氨酸，色氨酸可以转化为 5-羟色胺（也称血清素），这种神经递质可以使人感到镇定，从而有利于睡眠。小米安神也是同一个道理。不过，应该也不会这么快才对？

又或许是今天的经历使然吧。今天做了什么呢？打扫卫生，和组里的老师谈了下例会的事情，然后就是在写 Bomblab。这个作业拖了好久好久了，下周就是 DDL 了。周五那天胡乱拆了两个，本以为这周末拆两个就好，结果一晚上把剩下的四个都拆完了，顺便写了一部分的报告。

无论如何吧，这种平静的感觉，蛮好的。

晚安，各位老友。
